.\" Copyright (c) 1993 John Brezak
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. The name of the author may be used to endorse or promote products
.\"    derived from this software without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR `AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	$NetBSD: insque.3,v 1.3 2005/07/12 08:28:27 wiz Exp $
.\"
.Dd July 6, 2005
.Dt INSQUE 3
.Os
.Sh NAME
.Nm insque ,
.Nm remque
.Nd insert/remove element from a queue
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In search.h
.Ft void
.Fn insque "void *elem" "void *pred"
.Ft void
.Fn remque "void *elem"
.Sh DESCRIPTION
.Fn insque
and
.Fn remque
manipulate queues built from doubly linked lists.
The queue can be either circular or linear.
The functions expect their
arguments to point to a structure whose first and second members are
pointers to the next and previous element, respectively.
The
.Fn insque
function also allows the
.Fa pred
argument to be a
.Dv NULL
pointer for the initialization of a new linear list's
head element.
.Sh STANDARDS
The
.Fn insque
and
.Fn remque
functions conform to
.St -p1003.1-2001 .
.Sh HISTORY
These are derived from the insque and remque instructions on a VAX.
